/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic outline for a simple desktop window.

  ==============================================================================
*/

#include "MainWindow.h"
#include "cAHDSRComponent.h"
#include "resources.h"

#define kInnerCompBorder 5
#define kAhdsrCompHeightPercentage 0.80

class ContentComp : public Component,
                    public ChangeListener,
                    public Button::Listener
{
public:
    ContentComp(const String& componentName)
        : Component(componentName)
    {
        mBackgroundImage = ImageCache::getFromMemory( resources::background_png, resources::background_pngSize );

        mAhdsrComp.addChangeListener( this );

        addAndMakeVisible( &mAhdsrComp );

        mAddAnchorButton.setButtonText("Add");
        mAddAnchorButton.addListener(this);
        addAndMakeVisible(&mAddAnchorButton);

        mDeleteAnchorButton.setButtonText("Delete");
        mDeleteAnchorButton.addListener(this);
        addAndMakeVisible(&mDeleteAnchorButton);
    }

    ~ContentComp()
    {
    }

    #define kLabelWidth  100
    #define kLabelHeight 15
    #define kTextEditFieldWidth 50
    #define kTextEditFieldHeight 15
    #define kYOffset 5
    #define kXOffset 5

    void resized()
    {
        int ahdsrHeight = (int)((float)(getHeight() - (kInnerCompBorder * 3)) * kAhdsrCompHeightPercentage);
        mAhdsrComp.setBounds(kInnerCompBorder, kInnerCompBorder, getWidth() - (kInnerCompBorder * 2), ahdsrHeight);

        int dataViewStartY = ahdsrHeight + (kInnerCompBorder * 2);
        int dataViewHeight = getHeight() - ahdsrHeight - (kInnerCompBorder * 3);

        // test buttons
        mAddAnchorButton.setBounds(kInnerCompBorder, dataViewStartY + kYOffset, kLabelWidth, kLabelHeight );
        mDeleteAnchorButton.setBounds(kInnerCompBorder, dataViewStartY + kLabelHeight + (kYOffset * 2), kLabelWidth, kLabelHeight );
    }

    virtual void changeListenerCallback(ChangeBroadcaster* objectThatHasChanged )
    {
        if ( objectThatHasChanged == &mAhdsrComp )
        {
        }
    }

    virtual void buttonClicked(Button* button)
    {
        if (button == &mDeleteAnchorButton)
        {
            mAhdsrComp.deleteAnchor( 2 );
        }
        else if (button == &mAddAnchorButton)
        {
            cEnvelopeAnchor* testAnchor = new cEnvelopeAnchor;
            testAnchor->mX.mLocked = false;
            testAnchor->mY.mLocked = false;
            testAnchor->mX.mPercentage  = 0.20;
            testAnchor->mY.mPercentage = 1.0;
            testAnchor->mY.mFollowLeft = false;
            testAnchor->mY.mFollowRight = false;
            mAhdsrComp.addAnchor(testAnchor, 2);
            mAhdsrComp.recalculateCoordinates();
        }
    }

    void paint( Graphics& g )
    {
        int ahdsrHeight = (int)((float)(getHeight() - (kInnerCompBorder * 3)) * kAhdsrCompHeightPercentage);
        g.drawImage( mBackgroundImage, kInnerCompBorder, ahdsrHeight + (kInnerCompBorder * 2), getWidth() - (kInnerCompBorder * 2), getHeight() - ahdsrHeight - (kInnerCompBorder * 3), 0, 0, mBackgroundImage.getWidth(), mBackgroundImage.getHeight(), false );
    }

private:
    TextButton             mAddAnchorButton;
    TextButton             mDeleteAnchorButton;

    cAHDSRComponent   mAhdsrComp;

    Image             mBackgroundImage;
};

//==============================================================================
MainAppWindow::MainAppWindow()
    : DocumentWindow (JUCEApplication::getInstance()->getApplicationName(),
                      Colours::lightgrey,
                      DocumentWindow::allButtons)
{
    setResizable (true, false);

    ContentComp* contentComp = new ContentComp("Main Content");
    contentComp->setSize(500,400);

    setContentOwned(contentComp, true);

    centreWithSize (500, 400);

    setVisible (true);
}

MainAppWindow::~MainAppWindow()
{
}


void MainAppWindow::closeButtonPressed()
{
    JUCEApplication::getInstance()->systemRequestedQuit();
}
