#ifndef _C_AHDSR_COMPONENT_
#define _C_AHDSR_COMPONENT_

#include "../JuceLibraryCode/JuceHeader.h"

#include "cEnvelopeComponent.h"

class cAHDSRComponent : public cEnvelopeComponent
{
public:
    cAHDSRComponent();
    ~cAHDSRComponent();

    void setStartTimePercent( double startTimePercent );
    void setAttackTimePercent( double attackTimePercent );
    void setHoldTimePercent( double holdTimePercent );
    void setDecayTimePercent( double decayTimePercent );
    void setSustainTimePercent( double sustainTimePercent );
    void setSustainLevelPercent( double sustainLevel );
    void setReleaseTimePercent( double releaseTimePercent );
    void setTimePercents( double startTimePercent, double attackTimePercent, double holdTimePercent, double decayTimePercent, double sustainTimePercent, double releaseTimePercent );

    double getStartTimePercent( void ) { return( mEnvelopeAnchors[ eStartAnchor ]->mX.mPercentage ); }
    double getAttackTimePercent( void ) { return( mEnvelopeAnchors[ eAttackAnchor ]->mX.mPercentage ); }
    double getHoldTimePercent( void ) { return( mEnvelopeAnchors[ eHoldAnchor ]->mX.mPercentage ); }
    double getDecayTimePercent( void ) { return( mEnvelopeAnchors[ eDecayAnchor ]->mX.mPercentage ); }
    double getSusainTimePercent( void ) { return( mEnvelopeAnchors[ eSustainAnchor ]->mX.mPercentage ); }
    double getSustainLevel( void ) { return( mEnvelopeAnchors[ eSustainAnchor ]->mY.mPercentage ); }
    double getReleaseTimePercent( void ) { return( mEnvelopeAnchors[ eReleaseAnchor ]->mX.mPercentage ); }

    //==============================================================================
    juce_UseDebuggingNewOperator

private:
    enum
    {
        eNoAnchor = -1,
        eStartAnchor = 0,
        eAttackAnchor,
        eHoldAnchor,
        eDecayAnchor,
        eSustainAnchor,
        eReleaseAnchor,

        eAnchorCount
    };
};

#endif // _C_AHDSR_COMPONENT_
